On certain server setups, setting ApplicationContext fails, because the environment variable TYPO3_CONTEXT is never set.

The reason is that variables set by mod_rewrite get prefixed with REDIRECT_
This seems to appear in PHP-FPM setups, which is quite popular these days.

htaccess file:
 RewriteCond %{HTTP_HOST} ^dev\.example\.com$
 RewriteRule (.*) $1 [E=TYPO3_CONTEXT:Development]

Test:
echo $_SERVER['TYPO3_CONTEXT'];

echo $_SERVER['REDIRECT_TYPO3_CONTEXT'];
Development

Flow solves this by using REDIRECT_FLOW3_CONTEXT as fallback in index.php:

$context = getenv('FLOW3_CONTEXT') ?: (getenv('REDIRECT_FLOW3_CONTEXT') ?: 'Development');

We should backport this fallback to Bootstrap.

Related issues:
related to Core - Bug # 53188: REDIRECT_TYPO3_DISABLE_CORE_UPDATER ignored Resolved 2013-11-27 2013-11-27
related to Core - Bug # 53974: Environment variables prefixed with REDIRECT_ ... Resolved 2013-11-26

Associated revisions
Revision f2ef9fab - 2014-04-30 18:38 - Steffen Müller

[BUGFIX] Use REDIRECT_ prefix as fallback for environment variables

The core uses values of environment variables for
disabling the core updater and to determine the
application context.
When setting the variable with mod_rewrite, certain server environments
prefix the variable name with REDIRECT_.
To ensure compatibility for this case, REDIRECT_
prefix is prepended as a fallback if the regular
variable is not set.
Resolves: #58358
Releases: 6.2
Tested-by: Markus Klein
Reviewed-by: Steffen Müller
History
#1 - 2014-04-30 14:08 - Helmut Hummel
- Status changed from New to Closed

Duplicate of #53188

#2 - 2014-04-30 14:08 - Gerrit Code Review
- Status changed from Closed to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/29742

#3 - 2014-04-30 14:20 - Steffen Müller

Sorry Helmut, I pushed without noticing the duplicate.
Nevertheless, please don't close issues which are duplicates of yet unresolved. AFAIK the policy was to leave dups until the parent issue was resolved
and then close all dups.

Beside that, I don't agree this is a duplicate, but rather an issue which is related to the parent. the pending solution of the parent does not fix this issue.

#4 - 2014-04-30 14:20 - Steffen Müller
- Status changed from Under Review to Needs Feedback

#5 - 2014-04-30 15:33 - Gerrit Code Review
- Status changed from Needs Feedback to Under Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25123
#6 - 2014-04-30 15:50 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25123

#7 - 2014-04-30 16:03 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25123

#8 - 2014-04-30 16:33 - Steffen Müller
- Status changed from Under Review to Closed
